using GTA;
using GTA.Math;
using System;
using GTA.Native;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using System.Threading;
public class HitmanMod : Script
{
    bool isRunning = false;
    GTA.Ped ped;
    GTA.Ped bodyGuard;
    int reward;
    Vector3 vecc;
    Vehicle cur;
    bool changeNeeeded = false;
    public HitmanMod()
    {
        Tick += OnTick;
        
        KeyDown += OnKeyDown;
    }

    private void OnTick(object sender, EventArgs e)
    {
        
        if (isRunning)
        {
            if (ped.IsDead)
            {
                Game.Player.Money = Game.Player.Money + reward;
                UI.Notify(string.Format("Target has been killed, {0}$ awarded", reward.ToString()));
                ped.MarkAsNoLongerNeeded();
                getNewTarget();
            }
            else
            {
                
            }

            
        }
            
        
    }

    public void getNewTarget()
    { 
        Random rnd = new Random();
        int cases = rnd.Next(1, 11);

        switch(cases)
        {
            case 1:
                ped = GTA.World.CreatePed("a_m_y_musclbeac_02",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                
                reward = 500;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 2:
                ped = GTA.World.CreatePed("mp_m_fibsec_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                ped.Weapons.Give(WeaponHash.CombatPistol, 120, false, true); 
                reward = 10000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 3:
                ped = GTA.World.CreatePed("ig_fbisuit_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                ped.Weapons.Give(WeaponHash.StunGun, 120, false, true); 
                bodyGuard = GTA.World.CreatePed("s_m_y_swat_01",ped.Position.Around(2.0F));bodyGuard.Task.GoTo(ped);
                bodyGuard.Weapons.Give(WeaponHash.SpecialCarbine, 120, true, true); 
                bodyGuard = GTA.World.CreatePed("s_m_y_swat_01",ped.Position.Around(2.0F));bodyGuard.Task.GoTo(ped);
                bodyGuard.Weapons.Give(WeaponHash.AssaultShotgun, 120, true, true);
                bodyGuard = GTA.World.CreatePed("s_m_y_swat_01",ped.Position.Around(2.0F));bodyGuard.Task.GoTo(ped);
                bodyGuard.Weapons.Give(WeaponHash.CombatMG, 120, true, true); 
                bodyGuard = GTA.World.CreatePed("s_m_y_swat_01",ped.Position.Around(2.0F));bodyGuard.Task.GoTo(ped);
                bodyGuard.Weapons.Give(WeaponHash.AdvancedRifle, 120, true, true); 
                
                reward = 70000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 4:
                ped = GTA.World.CreatePed("a_m_m_og_boss_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                
                reward = 4000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 5:
                ped = GTA.World.CreatePed("a_m_m_paparazzi_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();    
                
                reward = 17000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 6:
                ped = GTA.World.CreatePed("a_m_y_mexthug_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();         
                
                reward = 700;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 7:
                ped = GTA.World.CreatePed("u_m_y_prisoner_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                ped.Weapons.Give(WeaponHash.Knife, 1, false, true);
                reward = 28000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 8:
                ped = GTA.World.CreatePed("s_m_y_armymech_01", getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                ped.Weapons.Give(WeaponHash.PumpShotgun, 120, false, true); 
                reward = 32000;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                
                break;

            case 9:
                ped = GTA.World.CreatePed("s_m_y_dealer_01",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();
                ped.Weapons.Give(WeaponHash.SNSPistol, 120, false, true); 
                reward = 150;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;


            case 10:
                ped = GTA.World.CreatePed("hc_hacker",getRandomPos());ped.AddBlip().SetAsHostile();ped.Task.WanderAround();           
                
                reward = 800;
                UI.Notify("New Target Available. Reward : " + reward.ToString() + "$");
                break;
                


        }
    }

    public Vector3 getRandomPos()
    {
        Vector3 vec = new Vector3();
        Random rnd = new Random();
        int random = rnd.Next(1, 17);

        switch(random)
        {
            case 1:
                vec.X = 1844;
                vec.Y = 3764;
                vec.Z = 33;
                break;

            case 2:
                vec.X = 83;
                vec.Y = -972;
                vec.Z = 29;
                break;

            case 3:
                vec.X = 166;
                vec.Y = -985;
                vec.Z = 30;
                break;

            case 4:
                vec.X = -794;
                vec.Y = -33;
                vec.Z = 37;
                break;

            case 5:
                vec.X = 1004;
                vec.Y = -1381;
                vec.Z = 31;
                break;

            case 6:
                vec.X = -205;
                vec.Y = -1440;
                vec.Z = 31;
                break;

            case 7:
                vec.X = 938;
                vec.Y = -2946;
                vec.Z = 5;
                break;

            case 8:
                vec.X = -637;
                vec.Y = -2234;
                vec.Z = 5;
                break;

            case 9:
                vec.X = -887;
                vec.Y = -2234;
                vec.Z = 6;
                break;

            case 10:
                vec.X = -729;
                vec.Y = -1152;
                vec.Z = 10;
                break;

            case 11:
                vec.X = -709;
                vec.Y = -868;
                vec.Z = 23;
                break;

            case 12:
                vec.X = 416;
                vec.Y = -155;
                vec.Z = 64;
                break;

            case 13:
                vec.X = 336;
                vec.Y = 329;
                vec.Z = 104;
                break;

            case 14:
                vec.X = -202;
                vec.Y = 3659;
                vec.Z = 51;
                break;

            case 15:
                vec.X = -1107;
                vec.Y = 2687;
                vec.Z = 18;
                break;

            case 16:
                vec.X = -1718;
                vec.Y = 160;
                vec.Z = 64;
                break;
        }

        return vec;
    }
    public void beginHitman()
    {
        if (isRunning)
        {
            isRunning = false;
            UI.Notify("Hitman Mod Deactivated");
            ped.MarkAsNoLongerNeeded();
            changeNeeeded = false;
        }
        else
        {
            isRunning = true;
            
            World.CreateVehicle(VehicleHash.Buffalo, Game.Player.Character.Position.Around(5.0F));
            getNewTarget();
            
            UI.Notify("Hitman Mod Activated");
            
            
        }
    }
    void OnKeyDown(object sender, KeyEventArgs e)
    {

        switch (e.KeyCode)
        {
            case Keys.F12: //Edit the key that you have to press here
                beginHitman();
                break;
        }
     
    }
}